## Steps to generate python bindings for Pravega:

*Pre-requisites*
- Python 3.8 and up.

1. Ensure `cargo build` works fine.
2. There are two ways of running generating bindings. This describes the steps where maturin is manually installed.
    - Manually install [maturin](https://github.com/PyO3/maturin) via `pip install maturin`
    - `maturin build --release --no-sdist --strip --manylinux off` This command auto detects the python interpreter and uses it. To
    specify a specific interpreter using `--interpreter` option.
    - `maturin sdist` to generate the source distribution. 
3. Steps to generate bindings using a docker approach.
    - `docker run --rm -v --release --no-sdist --strip --manylinux off`
4. After the bindings are generated by either 2 or 3 the next step is to publish the artifacts.
   - The artifacts can be published via [twine](https://github.com/pypa/twine)
        - `pip install twine`
        - `twine upload -r testpypi target/*` this command uploads the artifacts to test.pypi
        - `twine upload target/*` this command uploads the artifacts to pypi.
   - The artifacts can be published via [maturin](https://github.com/PyO3/maturin)
        - `maturin publish -b pyo3 -p XXX -u YYY -r https://test.pypi.org/legacy/` this publishes the bindings to test.pypi
        - `maturin publish -b pyo3 -p XXX -u YYY` This publishes the bindings to pypi.